package com.iformall.controller.market;

import com.alibaba.fastjson.JSONArray;
import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.base.BaseEntity;
import com.iformall.domain.po.WxGame;
import com.iformall.enums.EnumGameStatus;
import com.iformall.service.WxGameService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("wxGame")
@Api(description = "游戏接口")
public class WxGameController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxGameService wxGameService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "游戏-列表")
    public ResultData list(@ModelAttribute WxGame wxGame, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxGameController::list");
        if (null == wxGame) wxGame = new WxGame();
        wxGame.setTenantId(getTenantId());
        wxGame.setSortColumns(BaseEntity.SortField.Id_DESC);
        final PageInfo<WxGame> page = wxGameService.listAsPage(wxGame, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "游戏-新增")
    public ResultData add(@RequestBody WxGame wxGame) {
        logger.debug("[" + getIpAddr() + "] WxGameController::add");
        //Assert.notNull(wxGame.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        if (StringUtils.isBlank(wxGame.getCouponIds())) {
            wxGame.setCouponIds(JSONArray.toJSONString(new String[0]));
        }
        wxGame.setStatus(EnumGameStatus.STATUS_THROW_IN.getCode());
        wxGame.setTenantId(getTenantId());
        wxGameService.saveOrUpdate(wxGame);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "游戏-更新")
    public ResultData update(@RequestBody WxGame wxGame) {
        logger.debug("[" + getIpAddr() + "] WxGameController::update");
        if (StringUtils.isBlank(wxGame.getCouponIds())) {
            wxGame.setCouponIds(JSONArray.toJSONString(new String[0]));
        }
        wxGame.setTenantId(getTenantId());
        wxGameService.saveOrUpdate(wxGame);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "游戏-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxGameController::delete");
        wxGameService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "游戏-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxGameController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxGameService.getById(id));
    }


}
